#include <map>
#include <iostream>
#include <string>
#include <vector>
#include <set>

#include "split.h"

using std::cin;            using std::cout;
using std::endl;           using std::getline;
using std::istream;        using std::string;
using std::vector;         using std::map;
using std::set;

// find all the lines that refer to each word in the input
map<string, set<int> >
	xref(istream& in,
	     vector<string> find_words(const string&) = split)
{
	string line;
	int line_number = 0;
	map<string, set<int> > ret;

	// read the next line
	while (getline(in, line)) {
		++line_number;

		// break the input line into words
		vector<string> words = find_words(line);

		// remember that each word occurs on the current line
#ifdef _MSC_VER
		for (std::vector<string>::const_iterator it = words.begin();
#else
		for (vector<string>::const_iterator it = words.begin();
#endif
		     it != words.end(); ++it)
			ret[*it].insert(line_number);
	}
	return ret;
}

int main()
{
	// call `xref' using `split' by default
	map<string, set<int> > ret = xref(cin);

	// write the results
#ifdef _MSC_VER
	for (std::map<string, set<int> >::const_iterator it = ret.begin();
#else
	for (map<string, set<int> >::const_iterator it = ret.begin();
#endif
	     it != ret.end(); ++it) {
		// write the word
		cout << it->first << " occurs on line(s): ";

		// followed by one or more line numbers
#ifdef _MSC_VER
		std::set<int>::const_iterator line_it = it->second.begin();
#else
		set<int>::const_iterator line_it = it->second.begin();
#endif
		cout << *line_it;	// write the first line number

		++line_it;
		// write the rest of the line numbers, if any
		while (line_it != it->second.end()) {
			cout << ", " << *line_it;
			++line_it;
		}
		// write a new line to separate each word from the next
		cout << endl;
	}

	return 0;
}



#include <map>           // ӳ⣨mapڴ洢ÿĶӦϵ
#include <iostream>      // ׼
#include <string>        // ַ
#include <vector>        // 붯̬飨vector
#include <set>           // 뼯⣨setڴ洢к

#include "split.h"       // Զͷļsplit.hsplit

using std::cin;            // ׼
using std::cout;           // ׼
using std::endl;           // 뻻з
using std::getline;        // getlineжȡ
using std::istream;        // 
using std::string;         // ַ
using std::vector;         // 붯̬
using std::map;            // ӳ
using std::set;            // 뼯

// xref ÿгֵк
map<string, set<int> >
xref(istream& in,               // ĬΪcin
	vector<string> find_words(const string&) = split) // ʹsplitָʣĬϣ
{
	string line;                 // ڴ洢ÿеı
	int line_number = 0;         // ǰк
	map<string, set<int>> ret;   // 洢ʼֵкţʹmap<, set<к>>ṹ

	// жȡ
	while (getline(in, line)) {
		++line_number;  // к

		// ǰвΪʣʹfind_wordsĬsplit
		vector<string> words = find_words(line);

		// ǰеÿʣӦкŲ뵽map
		for (vector<string>::const_iterator it = words.begin(); it != words.end(); ++it)
			ret[*it].insert(line_number);  // ʼкŴmap
	}
	return ret;  // mapÿʼֵк
}

int main()
{
	// xrefĬʹsplitеʲ֣cin
	map<string, set<int>> ret = xref(cin);

	// ÿʼֵк
	for (map<string, set<int>>::const_iterator it = ret.begin(); it != ret.end(); ++it) {
		// 
		cout << it->first << " occurs on line(s): ";

		// õʳֵк
		set<int>::const_iterator line_it = it->second.begin();
		cout << *line_it;    // һк

		++line_it;
		// к
		while (line_it != it->second.end()) {
			cout << ", " << *line_it;
			++line_it;
		}

		// зԷָÿʵ
		cout << endl;
	}

	return 0;  // 
}
